"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_tools_fork_1 = require("graphql-tools-fork");
exports.renameTransform = async ({ schema, config }) => {
    var _a, _b, _c;
    const rootTypes = [
        (_a = schema.getQueryType()) === null || _a === void 0 ? void 0 : _a.name,
        (_b = schema.getMutationType()) === null || _b === void 0 ? void 0 : _b.name,
        (_c = schema.getSubscriptionType()) === null || _c === void 0 ? void 0 : _c.name
    ].filter(Boolean);
    const transforms = [];
    for (const change of config) {
        const [fromTypeName, fromFieldName] = change.from.split('.');
        const [toTypeName, toFieldName] = change.to.split('.');
        const isRootType = rootTypes.includes(fromTypeName);
        if (fromTypeName !== toTypeName) {
            if (isRootType) {
                transforms.push(new graphql_tools_fork_1.RenameRootTypes(t => (t === fromTypeName ? toTypeName : t)));
            }
            else {
                transforms.push(new graphql_tools_fork_1.RenameTypes(t => (t === fromTypeName ? toTypeName : t)));
            }
        }
        if (fromFieldName && toFieldName && fromFieldName !== toFieldName) {
            if (isRootType) {
                transforms.push(new graphql_tools_fork_1.RenameRootFields((typeName, fieldName) => typeName === toTypeName && fieldName === fromFieldName
                    ? toFieldName
                    : fieldName));
            }
            else {
                transforms.push(new graphql_tools_fork_1.RenameObjectFields((typeName, fieldName) => typeName === toTypeName && fieldName === fromFieldName
                    ? toFieldName
                    : fieldName));
            }
        }
    }
    return graphql_tools_fork_1.transformSchema(schema, transforms);
};
exports.default = exports.renameTransform;
//# sourceMappingURL=index.js.map